#!/bin/bash
#cifs_create_proxy_user.sh
#
# Copyright @[2012] Novell, Inc.  All Rights Reserved.
#
# USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE DEVELOPER LICENSE
# AGREEMENT OR OTHER AGREEMENT THROUGH WHICH NOVELL, INC. MAKES THE WORK
# AVAILABLE. THIS WORK MAY NOT BE ADAPTED WITHOUT  NOVELL'S PRIOR WRITTEN
# CONSENT.
#
# NOVELL PROVIDES THE WORK "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY,
# INCLUDING WITHOUT THE IMPLIED WARRANTIES OF MERCHANTABILITY,FITNESS FOR
# A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  NOVELL, THE AUTHORS OF THE
# WORK, AND THE OWNERS OF COPYRIGHT IN THE WORK ARE NOT LIABLE FOR ANY
# CLAIM, DAMAGES, OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT, OR OTHERWISE, ARISING FROM, OUT OF, OR IN CONNECTION WITH THE WORK
# OR THE USE OR OTHER DEALINGS IN THE WORK.
#
# All rights reserved.
#
#
													    
user_id=`id -u`
if test $user_id -ne 0
then
        echo "cifs_create_proxy_user.sh : Only root user can run this script"
        exit 1
fi
LOG_FILE="/var/opt/novell/log/proxymgmt/pxymgmt.log"

cifsProxyUser=$1
cifsPassword="$OES_DATA2"
logindn=$2
password="$OES_DATA"
hostname=$3
port=$4
ssl=$5

if test $# == 5
then
        TMP_ADD_PROXYUSER_LDIFFILE=/tmp/addcifsproxy.ldif
        LDAP_ADD_BINARY="env LDAPTLS_CACERT=/etc/opt/novell/certs/SSCert.pem /usr/bin/ldapmodify -a"
        LDAP_SEARCH_BINARY="env LDAPTLS_CACERT=/etc/opt/novell/certs/SSCert.pem /usr/bin/ldapsearch"
        LDAP_MOD_BIN="env LDAPTLS_CACERT=/etc/opt/novell/certs/SSCert.pem /usr/bin/ldapmodify"
        mkdir -p /tmp
        touch $TMP_ADD_PROXYUSER_LDIFFILE

        echo "dn: "$1 >> $TMP_ADD_PROXYUSER_LDIFFILE
        echo "givenName: User" >> $TMP_ADD_PROXYUSER_LDIFFILE
        echo "sn: CIFSProxy" >> $TMP_ADD_PROXYUSER_LDIFFILE
        echo "objectClass: inetOrgPerson" >> $TMP_ADD_PROXYUSER_LDIFFILE
        echo "userPassword: "$OES_DATA2 >> $TMP_ADD_PROXYUSER_LDIFFILE
        #echo $LDAP_ADD_BINARY -f $TMP_ADD_PROXYUSER_LDIFFILE -D "$2" -w "$OES_DATA" -H ldaps://"$3":$4 >> $LOG_FILE

        if [ $ssl != 0 ]
        then
                 $LDAP_ADD_BINARY -f $TMP_ADD_PROXYUSER_LDIFFILE -D "$2" -w "$OES_DATA" -H ldaps://"$3":$4
        else
                 $LDAP_ADD_BINARY -f $TMP_ADD_PROXYUSER_LDIFFILE -D "$2" -w "$OES_DATA" -H ldap://"$3":$4
        fi

        LDAP_ADD_OUT=$?
        rm $TMP_ADD_PROXYUSER_LDIFFILE

        if test  $LDAP_ADD_OUT == 68
              then
                      $LDAP_SEARCH_BINARY -b "" -s base -D "$1" -w "$OES_DATA2" -H ldaps://"$3":$4
                      LDAP_ADD_OUT=$?
                      if test $LDAP_ADD_OUT != 0
                      then
                              echo "[CIFS]User is already existing but credentials did not match" >>$LOG_FILE
			      rm -f $TMP_ADD_PROXYUSER_LDIFFILE
                              exit $LDAP_ADD_OUT
                      else
                              echo "[CIFS]Proxy User already existing in eDirectory" >>$LOG_FILE
                      fi
        fi

        if test $LDAP_ADD_OUT != 0
        then
                echo "CIFS Proxy User creation failed. Return value: $LDAP_ADD_OUT \n" >>$LOG_FILE
		rm -f $TMP_ADD_PROXYUSER_LDIFFILE
                exit $LDAP_ADD_OUT
        fi
	rm -f $TMP_ADD_PROXYUSER_LDIFFILE
        exit 0
else
        echo "Usage: cifs_create_proxy_user.sh <proxy_fdn> <bind_fdn> <ldapserver_ip> <ldap_port> <SSL/NonSSL>";
        exit 1
fi

